Index: src/edu/ucsb/nceas/metacat/ReplicationHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/ReplicationHandler.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/ReplicationHandler.java	(revision 4080)
@@ -27,6 +27,10 @@
 package edu.ucsb.nceas.metacat;
 
 import edu.ucsb.nceas.dbadapter.AbstractDatabase;
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
 import java.sql.*;
 import java.util.*;
 import java.util.Date;
@@ -58,7 +62,6 @@
 public class ReplicationHandler extends TimerTask
 {
   int serverCheckCode = 1;
-  MetaCatUtil util = new MetaCatUtil();
   ReplicationServerList serverList = null;
   //PrintWriter out;
   private static final AbstractDatabase dbAdapter = MetaCatUtil.dbAdapter;
@@ -141,7 +144,6 @@
     // them in to response
     for (int i=0; i<serverList.size(); i++)
     {
-    	
         // Get ReplicationServer object from server list
         replServer = serverList.serverAt(i);
         // Get server name from ReplicationServer object
@@ -152,7 +154,7 @@
         try
         {
           u = new URL("https://" + server + "?server="
-          +util.getLocalReplicationServerName()+"&action=update");
+          +MetaCatUtil.getLocalReplicationServerName()+"&action=update");
           logMetacat.info("Sending infomation " +u.toString());
           result = MetacatReplication.getURLContent(u);
         }
@@ -296,7 +298,7 @@
       serialNumber=dbConn.getCheckOutSerialNumber();
       //if the document needs to be updated or inserted, this is executed
       String readDocURLString = "https://" + remoteserver + "?server="+
-              util.getLocalReplicationServerName()+"&action=read&docid="+accNumber;
+              MetaCatUtil.getLocalReplicationServerName()+"&action=read&docid="+accNumber;
       readDocURLString = MetaCatUtil.replaceWhiteSpaceForURL(readDocURLString);
       URL u = new URL(readDocURLString);
 
@@ -314,7 +316,7 @@
       DocInfoHandler dih = new DocInfoHandler();
       XMLReader docinfoParser = initParser(dih);
       String docInfoURLStr = "https://" + remoteserver +
-                       "?server="+util.getLocalReplicationServerName()+
+                       "?server="+MetaCatUtil.getLocalReplicationServerName()+
                        "&action=getdocumentinfo&docid="+accNumber;
       docInfoURLStr = MetaCatUtil.replaceWhiteSpaceForURL(docInfoURLStr);
       URL docinfoUrl = new URL(docInfoURLStr);
@@ -329,7 +331,7 @@
       String createdDate = (String)docinfoHash.get("date_created");
       String updatedDate = (String)docinfoHash.get("date_updated");
       //docid should include rev number too
-      /*String accnum=docId+util.getOption("accNumSeparator")+
+      /*String accnum=docId+util.getProperty("accNumSeparator")+
                                               (String)docinfoHash.get("rev");*/
       logMetacat.info("docid in repl: "+accNumber);
       String docType = (String)docinfoHash.get("doctype");
@@ -432,7 +434,7 @@
       DocInfoHandler dih = new DocInfoHandler();
       XMLReader docinfoParser = initParser(dih);
       String docInfoURLString = "https://" + remoteserver +
-                  "?server="+util.getLocalReplicationServerName()+
+                  "?server="+MetaCatUtil.getLocalReplicationServerName()+
                   "&action=getdocumentinfo&docid="+accNumber;
       docInfoURLString = MetaCatUtil.replaceWhiteSpaceForURL(docInfoURLString);
       URL docinfoUrl = new URL(docInfoURLString);
@@ -452,14 +454,14 @@
       String createdDate = (String)docinfoHash.get("date_created");
       String updatedDate = (String)docinfoHash.get("date_updated");
       //docid should include rev number too
-      /*String accnum=docId+util.getOption("accNumSeparator")+
+      /*String accnum=docId+util.getProperty("accNumSeparator")+
                                               (String)docinfoHash.get("rev");*/
 
 
-      String datafilePath = util.getOption("datafilepath");
+      String datafilePath = PropertyService.getProperty("application.datafilepath");
       // Get data file content
       String readDataURLString = "https://" + remoteserver + "?server="+
-                                        util.getLocalReplicationServerName()+
+                                        MetaCatUtil.getLocalReplicationServerName()+
                                             "&action=readdata&docid="+accNumber;
       readDataURLString = MetaCatUtil.replaceWhiteSpaceForURL(readDataURLString);
       URL u = new URL(readDataURLString);
@@ -556,7 +558,7 @@
 
          //because delete method docid should have rev number
          //so we just add one for it. This rev number is no sence.
-         String accnum=docId+util.getOption("accNumSeparator")+"1";
+         String accnum=docId+PropertyService.getProperty("accNumSeparator")+"1";
          //System.out.println("accnum: "+accnum);
          DocumentImpl.delete(accnum, null, null, notifyServer);
          logMetacat.info("Successfully deleted doc " + docId);
@@ -600,7 +602,7 @@
       logMetacat.info("Try to update last_check for server: "+server);
       // Get time from remote server
       URL dateurl = new URL("https://" + server + "?server="+
-      util.getLocalReplicationServerName()+"&action=gettime");
+      MetaCatUtil.getLocalReplicationServerName()+"&action=gettime");
       String datexml = MetacatReplication.getURLContent(dateurl);
       logMetacat.info("datexml: "+datexml);
       if (datexml!=null && !datexml.equals(""))
@@ -673,7 +675,7 @@
         server = replServer.getServerName();
         // Try to get catalog
         URL u = new URL("https://" + server + "?server="+
-        util.getLocalReplicationServerName()+"&action=getcatalog");
+        MetaCatUtil.getLocalReplicationServerName()+"&action=getcatalog");
         logMetacat.info("sending message " + u.toString());
         String catxml = MetacatReplication.getURLContent(u);
 
@@ -894,8 +896,7 @@
       ContentHandler chandler = dh;
 
       // Get an instance of the parser
-      MetaCatUtil util = new MetaCatUtil();
-      String parserName = util.getOption("saxparser");
+      String parserName = PropertyService.getProperty("saxparser");
       parser = XMLReaderFactory.createXMLReader(parserName);
 
       // Turn off validation
@@ -999,68 +1000,61 @@
   
   
   /*
-   * This method will go through the docid list both in xml_Documents table
-   * and in xml_revisions table
-   * @author tao
-   */
-   private void handleDocList(Vector docList, String tableName)
-   {
-       boolean dataFile=false;
-       for(int j=0; j<docList.size(); j++)
-       {
-         //initial dataFile is false
-         dataFile=false;
-         //w is information for one document, information contain
-         //docid, rev, server or datafile.
-         Vector w = new Vector((Vector)(docList.elementAt(j)));
-         //Check if the vector w contain "datafile"
-         //If it has, this document is data file
-         if (w.contains((String)util.getOption("datafileflag")))
-         {
-           dataFile=true;
-         }
-         //System.out.println("w: " + w.toString());
-         // Get docid
-         String docid = (String)w.elementAt(0);
-         logMetacat.info("docid: " + docid);
-         // Get revision number
-         int rev = Integer.parseInt((String)w.elementAt(1));
-         logMetacat.info("rev: " + rev);
-         // Get remote server name (it is may not be doc homeserver because
-         // the new hub feature
-         String remoteServer = (String)w.elementAt(2);
-         remoteServer = remoteServer.trim();
+	 * This method will go through the docid list both in xml_Documents table
+	 * and in xml_revisions table @author tao
+	 */
+	private void handleDocList(Vector docList, String tableName) {
+		boolean dataFile = false;
+		for (int j = 0; j < docList.size(); j++) {
+			// initial dataFile is false
+			dataFile = false;
+			// w is information for one document, information contain
+			// docid, rev, server or datafile.
+			Vector w = new Vector((Vector) (docList.elementAt(j)));
+			// Check if the vector w contain "datafile"
+			// If it has, this document is data file
+			try {
+				if (w.contains((String) PropertyService.getProperty("datafileflag"))) {
+					dataFile = true;
+				}
+			} catch (PropertyNotFoundException pnfe) {
+				logMetacat.error("Could not retrieve data file flag property.  "
+						+ "Leaving as false: " + pnfe.getMessage());
+			}
+			// System.out.println("w: " + w.toString());
+			// Get docid
+			String docid = (String) w.elementAt(0);
+			logMetacat.info("docid: " + docid);
+			// Get revision number
+			int rev = Integer.parseInt((String) w.elementAt(1));
+			logMetacat.info("rev: " + rev);
+			// Get remote server name (it is may not be doc homeserver because
+			// the new hub feature
+			String remoteServer = (String) w.elementAt(2);
+			remoteServer = remoteServer.trim();
 
-         try
-         {
-             if (tableName.equals(DocumentImpl.DOCUMENTTABLE))
-             {
-                 handleDocInXMLDocuments(docid, rev, remoteServer, dataFile);
-             }
-             else if (tableName.equals(DocumentImpl.REVISIONTABLE))
-             {
-                 handleDocInXMLRevisions(docid, rev, remoteServer, dataFile);
-             }
-             else
-             {
-                 continue;
-             }
-                 
-         }
-         catch (Exception e)
-         {
-             logMetacat.error("error to handle update doc in "+ 
-                     tableName +" in time replication"+e.getMessage());
-             continue;
-         }
-        
-       }//for update docs
+			try {
+				if (tableName.equals(DocumentImpl.DOCUMENTTABLE)) {
+					handleDocInXMLDocuments(docid, rev, remoteServer, dataFile);
+				} else if (tableName.equals(DocumentImpl.REVISIONTABLE)) {
+					handleDocInXMLRevisions(docid, rev, remoteServer, dataFile);
+				} else {
+					continue;
+				}
 
-   }
+			} catch (Exception e) {
+				logMetacat.error("error to handle update doc in " + tableName
+						+ " in time replication" + e.getMessage());
+				continue;
+			}
+
+		}// for update docs
+
+	}
    
    /*
-    * This method will handle doc in xml_documents table.
-    */
+	 * This method will handle doc in xml_documents table.
+	 */
    private void handleDocInXMLDocuments(String docid, int rev, String remoteServer, boolean dataFile) 
                                         throws Exception
    {
@@ -1118,7 +1112,7 @@
          }
        }
        
-       String accNumber = docid + MetaCatUtil.getOption("accNumSeparator") + rev;
+       String accNumber = docid + PropertyService.getProperty("accNumSeparator") + rev;
        // this is non-data file
        if(flag && !dataFile)
        {
@@ -1184,7 +1178,7 @@
            flag = true;    
        }
      
-       String accNumber = docid + MetaCatUtil.getOption("accNumSeparator") + rev;
+       String accNumber = docid + PropertyService.getProperty("accNumSeparator") + rev;
        // this is non-data file
        if(flag && !dataFile)
        {
Index: src/edu/ucsb/nceas/metacat/service/ServiceInterface.java
===================================================================
--- src/edu/ucsb/nceas/metacat/service/ServiceInterface.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/service/ServiceInterface.java	(revision 4080)
@@ -0,0 +1,44 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: A Class that implements utility methods like:
+ *             1/ Reding all doctypes from db connection
+ *             2/ Reading DTD or Schema file from Metacat catalog system
+ *             3/ Reading Lore type Data Guide from db connection
+ *  Copyright: 2000 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Jivka Bojilova
+ * 
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.service;
+
+/**
+ * A suite of utility classes for querying DB
+ * 
+ */
+public interface ServiceInterface {
+
+	public boolean isRestartable = false;
+	
+	/**
+	 * TODO MCD define register(), restartable() and restart() abstract methods
+	 */
+
+}

Index: src/edu/ucsb/nceas/metacat/AccessionNumber.java
===================================================================
--- src/edu/ucsb/nceas/metacat/AccessionNumber.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/AccessionNumber.java	(revision 4080)
@@ -32,6 +32,9 @@
 import java.sql.SQLException;
 
 import edu.ucsb.nceas.dbadapter.AbstractDatabase;
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 
 /**
  * (on insert of XML document)
@@ -50,21 +53,28 @@
   private String docid = null;
   private String rev = null;
 
+    /**
+	 * Construct an AccessionNumber
+	 */
+	private AccessionNumber() throws AccessionNumberException {
+		try {
+			this.sitecode = PropertyService.getProperty("sitecode");
+			this.sep = PropertyService.getProperty("accNumSeparator");
+		} catch (PropertyNotFoundException pnfe) {
+			throw new AccessionNumberException("Could not retrieve property "
+					+ "in constructor: " + pnfe.getMessage());
+		}
+	}
+
   /**
-   * Construct an AccessionNumber
-   */
-  private AccessionNumber ()
-  {
-    this.sitecode = MetaCatUtil.getOption("sitecode");
-    this.sep = MetaCatUtil.getOption("accNumSeparator");
-  }
-
-  /** NEW - WHEN CLIENT ALWAYS PROVIDE ACCESSION NUMBER INCLUDING REV IN IT
-   * Construct an AccessionNumber
-   *
-   * @param conn the db connection to read Accession number from
-   * @param accnum the accession number to be checked for validness
-   */
+	 * NEW - WHEN CLIENT ALWAYS PROVIDE ACCESSION NUMBER INCLUDING REV IN IT
+	 * Construct an AccessionNumber
+	 * 
+	 * @param conn
+	 *            the db connection to read Accession number from
+	 * @param accnum
+	 *            the accession number to be checked for validness
+	 */
   public AccessionNumber (String accnum, String action)
            throws AccessionNumberException, SQLException, NumberFormatException
  {
Index: src/edu/ucsb/nceas/metacat/util/SkinUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/util/SkinUtil.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/util/SkinUtil.java	(revision 4080)
@@ -0,0 +1,75 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: A Class that implements administrative methods 
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ * 
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.util;
+
+import java.util.Vector;
+
+import org.apache.log4j.Logger;
+
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+import edu.ucsb.nceas.utilities.StringUtil;
+
+public class SkinUtil {
+	
+	private static Logger logMetacat = Logger.getLogger(SkinUtil.class);
+
+	/**
+	 * private constructor - all methods are static so there is no no need to
+	 * instantiate.
+	 */
+	private SkinUtil() {
+	}
+		
+	/**
+	 * Reports whether skins are fully configured.
+	 * 
+	 * @return a boolean that is true if skins are not unconfigured and false
+	 *         otherwise
+	 */
+	public static boolean areSkinsConfigured() throws UtilException {
+		try {
+			return !PropertyService.getProperty("configutil.skinsConfigured").equals(
+					PropertyService.UNCONFIGURED);
+		} catch (PropertyNotFoundException pnfe) {
+			throw new UtilException("Could not determine if database is configured: "
+					+ pnfe.getMessage());
+		}
+	}
+
+	/**
+	 * Gets a list of available skin names by parsing a csv property from
+	 * metacat.properties.
+	 * 
+	 * @return a Vector of Strings holding skin names
+	 */
+	public static Vector<String> getSkinNames() throws PropertyNotFoundException {
+		String skinStringList = PropertyService.getProperty("skin.names");
+		return StringUtil.toVector(skinStringList, ',');
+	}
+
+}

Index: src/edu/ucsb/nceas/metacat/util/ResponseUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/util/ResponseUtil.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/util/ResponseUtil.java	(revision 4080)
@@ -0,0 +1,60 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: A Class that implements administrative methods 
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ * 
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.util;
+
+import java.io.IOException;
+
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+
+import org.apache.log4j.Logger;
+
+public class ResponseUtil {
+	
+	private static Logger logMetacat = Logger.getLogger(ResponseUtil.class);
+	
+	/**
+	 * private constructor - all methods are static so there is no
+     * no need to instantiate.
+	 */
+	private ResponseUtil() {}
+	
+	/**
+	 * Redirect a response.
+	 * 
+	 * @param response
+	 *            that is to be redirected
+	 * @param destination
+	 *            the context-relative URL to which the request is forwarded
+	 */
+	public static void redirectResponse(HttpServletRequest request,
+			HttpServletResponse response, String destination)
+			throws IOException {
+		logMetacat.debug("Redirecting response to " + request.getContextPath() + destination);
+		response.sendRedirect(request.getContextPath() + destination);
+	}
+}

Index: src/edu/ucsb/nceas/metacat/DocumentIdQuery.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocumentIdQuery.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/DocumentIdQuery.java	(revision 4080)
@@ -28,6 +28,7 @@
 import java.util.Hashtable;
 
 import edu.ucsb.nceas.utilities.Options;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 
 /**
  * Generate a pathquery document representing a metacat query for a list of 
@@ -60,7 +61,7 @@
      * 
      * @param docidList an array of document identifiers to search for
      */
-    public static String createDocidQuery(String[] docidList)
+    public static String createDocidQuery(String[] docidList) throws PropertyNotFoundException
     {
         String pathQuery = "";
         Hashtable params = getDefaultQueryParams();
@@ -134,7 +135,12 @@
         ids[1] = "knb-lter-vcr.97.1";
         ids[2] = "obfs.400.1";
         
-        String pathquery = createDocidQuery(ids);
+        String pathquery = null;
+        try {
+        	pathquery = createDocidQuery(ids);
+        } catch (PropertyNotFoundException pnfe) {
+        	System.out.println("Could not create doc id query: " + pnfe.getMessage());
+        }
         System.out.println(pathquery);
     }
 
Index: src/edu/ucsb/nceas/metacat/IndexingTimerTask.java
===================================================================
--- src/edu/ucsb/nceas/metacat/IndexingTimerTask.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/IndexingTimerTask.java	(revision 4080)
@@ -33,7 +33,9 @@
 import java.util.Vector;
 import java.util.Iterator;
 
-import edu.ucsb.nceas.metacat.MetaCatUtil;
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+
 import org.apache.log4j.Logger;
 
 public class IndexingTimerTask extends TimerTask{
@@ -57,7 +59,7 @@
 	    		
 	    		dbConn = DBConnectionPool.getDBConnection("IndexingThread");
 	    		serialNumber = dbConn.getCheckOutSerialNumber();
-	            Vector indexNamespaces = MetaCatUtil.getOptionList(MetaCatUtil.getOption("indexNamespaces"));
+	            Vector indexNamespaces = MetaCatUtil.getOptionList(PropertyService.getProperty("indexNamespaces"));
 	            String nonJoinCriteria = "b.docid is NULL";
 	    		boolean first = true;
 
